#include "generate.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <gnome.h>
#include "defines.h"
#include "callbacks.h"
#include "vroom.h"
#include <time.h>

#define KLINE_SIZE 2000
#define KPR_SIZE 200
extern _vroom;
	GtkWidget *textview;
	GtkWidget *textbuffer;

extern _vexitnode;
extern _vroom;
extern preview_dialog;

int substitude(char *mline,struct _vroom *cr,int flag, FILE *fp)
{
	int size1, size2,sz;
	char line[KLINE_SIZE];
	char *found;
	char prefound[KPR_SIZE];
	char copy_line[KLINE_SIZE];
	PangoFontDescription *fontdesc;
	struct _vexitnode *tmp_exit_node;
	char *post_found;
	int i;

	char *cex[]={
	SOUTHWEST_IS,
	SOUTH_IS,
	SOUTHEAST_IS,
	WEST_IS,
	EAST_IS,
	NORTHWEST_IS, 
	NORTH_IS,
	NORTHEAST_IS };

	memset(line,0x0,KLINE_SIZE);
	memset(prefound,0x0,KPR_SIZE);
	strcpy(line,mline);


	found=0;
	found=strstr(line,"%");

	if (found!=0)
	{
			memset(prefound,0x0,KPR_SIZE);
	
		found=0;
		found=strstr(line,"%exits");
		size1=strlen(line);
	

	
		if (found!=NULL) 
		{
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);

			for (i=0; i<8; i++)
			{
				if (cr->room_ptr[i]!=0)
				{
					strcat(copy_line,"\t\t\"");
					strcat(copy_line,cex[i]);
					strcat(copy_line,"\"  :\t");
					strcat(copy_line,ROOM_PREFIX);
					strcat(copy_line," \"");
					strcat(copy_line,AREA_NAME);
					strcat(copy_line,cr->room_ptr[i]->id);
					strcat(copy_line,FILE_EXT);
					strcat(copy_line,"\"");
					strcat(copy_line,ROOM_POSTFIX);
					strcat(copy_line,",\n");
				}
			}
	
			if (cr->up) {
				strcat(copy_line,"\t\t \"");
				strcat(copy_line,UP_IS);
				strcat(copy_line,"\"  :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->up->id);
				strcat(copy_line,FILE_EXT);
					strcat(copy_line,"\"");
					strcat(copy_line,ROOM_POSTFIX);
					strcat(copy_line,",\n");
			}
		
			if (cr->down) {
				strcat(copy_line,"\t\t \"");
				strcat(copy_line,DOWN_IS);
				strcat(copy_line,"\"  :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->down->id);
				strcat(copy_line,FILE_EXT);
					strcat(copy_line,"\"");
					strcat(copy_line,ROOM_POSTFIX);
					strcat(copy_line,",\n");
			}
		
			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
				
				strcat(copy_line,"\t\t\"");
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,"\" :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,tmp_exit_node->room_ptr->id);
				strcat(copy_line,FILE_EXT);
					strcat(copy_line,"\"");
					strcat(copy_line,ROOM_POSTFIX);
					strcat(copy_line,",\n");
	
				tmp_exit_node=tmp_exit_node->next;
			}
			
			found+=strlen("%exits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
		
		found=0;	
		found=strstr(line,"%oexits");
		size1=strlen(line);
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);
	
			for (i=0; i<8; i++)
			{
				if (cr->room_ptr[i]!=0)
				{
					strcat(copy_line,"\t\t\"");
					strcat(copy_line,cex[i]);
					strcat(copy_line,"\"  :\t");
					strcat(copy_line,ROOM_PREFIX);
					strcat(copy_line," \"");
					strcat(copy_line,AREA_NAME);
					strcat(copy_line,cr->room_ptr[i]->id);
					strcat(copy_line,FILE_EXT);
					strcat(copy_line,"\"");
					strcat(copy_line,ROOM_POSTFIX);
					strcat(copy_line,",\n");
				}
			}
	
			if (cr->up) {
				strcat(copy_line,"\t\t \"");
				strcat(copy_line,UP_IS);
				strcat(copy_line,"\"  :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->up->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,",\n");
			}
		
			if (cr->down) {
				strcat(copy_line,"\t\t \"");
				strcat(copy_line,DOWN_IS);
				strcat(copy_line,"\"  :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->down->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,",\n");
			}
			found+=strlen("%oexits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
			
		}
		
	
		found=0;
		found=strstr(line,"%mexits");
		size1=strlen(line);
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);
		
			
			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
				strcat(copy_line,"\t\t\"");
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,"\" :\t");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,tmp_exit_node->room_ptr->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,"\",\n");
	
				tmp_exit_node=tmp_exit_node->next;
				
			}
	
			found+=strlen("%mexits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
	
		}
		
	
		found=0;	
		found=strstr(line,"%soexits");
		size1=strlen(line);
		
		int ff;
		ff=0;
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);
			
		
			for (i=0; i<8; i++)
			{
				if (cr->room_ptr[i]!=0)
				{
					ff=1;
					strcat(copy_line,cex[i]);
					strcat(copy_line,", ");
				}
			}
			if (cr->up) { 
			strcat(copy_line,UP_IS);
			strcat(copy_line,", "); ff=1; }
			if (cr->down) { 
			strcat(copy_line,DOWN_IS);
			strcat(copy_line,", "); ff=1; }
	
			if (ff==1) copy_line[strlen(copy_line)-2]='\0';
	
			found+=strlen("%soexits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
		
//smexi	ts
	
		ff=0;
		found=0;	
		found=strstr(line,"%smexits");
		size1=strlen(line);
	
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);
			
			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
				ff=1;
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,", ");
				tmp_exit_node=tmp_exit_node->next;
			}
		
			if (ff==1) copy_line[strlen(copy_line)-2]='\0';
	
	
			found+=strlen("%smexits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
			}
		

//sexits

		ff=0;
		found=0;	
		found=strstr(line,"%sexits");
		size1=strlen(line);
	
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strncpy(prefound,line,sz);
			strcpy(copy_line,prefound);
			
			for (i=0; i<8; i++)
			{
				if (cr->room_ptr[i]!=0)
				{
					ff=1;
					strcat(copy_line,cex[i]);
					strcat(copy_line,", ");
				}
			}
	
			if (cr->up) { 
			strcat(copy_line,UP_IS);
			strcat(copy_line,", "); ff=1; }
		
			if (cr->down) { 
			strcat(copy_line,DOWN_IS);
			strcat(copy_line,", "); ff=1; }
		
			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
				ff=1;
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,", ");
				tmp_exit_node=tmp_exit_node->next;
			}
			
			if (ff==1) copy_line[strlen(copy_line)-2]='\0';
	

			found+=strlen("%sexits");	
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}


//room_id
		found=0;	
		found=strstr(line,"%room_id");
		size1=strlen(line);
	
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			if (sz!=0) strncpy(prefound,line,sz);
			if (sz==0) strcpy(prefound,"");
			strcpy(copy_line,prefound);	
			strcat(copy_line,cr->id);
			found+=strlen("%room_id");
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
//creator

		found=0;	
		found=strstr(line,"%creator_name");
		size1=strlen(line);
	
		if (found!=0)
		{
			
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			
			if (sz!=0) strncpy(prefound,line,sz);
			if (sz==0) strcpy(prefound,"");
			strcpy(copy_line,prefound);	
			strcat(copy_line,CREATOR_NAME);
			found+=strlen("%creator_name");
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
//comment

		found=0;	
		found=strstr(line,"%comment");
		size1=strlen(line);
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			if (sz!=0) strncpy(prefound,line,sz);
			if (sz==0) strcpy(prefound,"");
			strcat(prefound,"\0");
			strcpy(copy_line,prefound);	
			strcat(copy_line,COMMENT);
			found+=strlen("%comment");
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
	
//date
	
		time_t crt;
		found=0;	
		found=strstr(line,"%date");
		size1=strlen(line);
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			if (sz!=0) strncpy(prefound,line,sz);
			if (sz==0) strcpy(prefound,"");
			strcat(prefound,"\0");
			strcpy(copy_line,prefound);	
			crt=time(0);
			strcat(copy_line,ctime(&crt));
			found+=strlen("%date");
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
//areaname

		found=0;	
		found=strstr(line,"%area_name");
		size1=strlen(line);
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			if (sz!=0) strncpy(prefound,line,sz);
			if (sz==0) strcpy(prefound,"");
			
			strcpy(copy_line,prefound);	
			strcat(copy_line,AREA_NAME);
			found+=strlen("%area_name");
			strcat(copy_line,found);
			strcpy(line,copy_line);
		}
		
//for_exits
		
		found=0;	
		found=strstr(line,"%for_exits");
		size1=strlen(line);
		
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strcpy(copy_line,"");
			strncpy(prefound,line,sz);
			
			post_found=found+strlen("%for_exits");
			
			for (i=0; i<8; i++)
			{
				if (cr->room_ptr[i]!=0)
				{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,cex[i]);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->room_ptr[i]->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				//cex[i]
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				}
			}

			if (cr->up)
			{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,UP_IS);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->up->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,"\"");
				//cex[i]
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				
			}
		
			if (cr->down)
			{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,DOWN_IS);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->down->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				
			}
		
			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
			//	strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,tmp_exit_node->room_ptr->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
			
				tmp_exit_node=tmp_exit_node->next;
			}


			
			strcpy(line,copy_line);
		}



//// %for_oexits
		found=0;	
		found=strstr(line,"%for_oexits");
		size1=strlen(line);
	
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strcpy(copy_line,"");
			strncpy(prefound,line,sz);
			post_found=found+strlen("%for_oexits");
			
			for (i=0; i<8; i++)
			{
			
				if (cr->room_ptr[i]!=0)
				{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,cex[i]);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->room_ptr[i]->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				//cex[i]
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				}
			}

			if (cr->up)
			{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,UP_IS);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->up->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				//cex[i]
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				
			}
		
			if (cr->down)
			{
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,DOWN_IS);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,cr->down->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
				
			}
		
			strcpy(line,copy_line);
		}
///

//%for_mexits
		found=0;	
		found=strstr(line,"%for_mexits");
		size1=strlen(line);
	
		if (found!=0)
		{
			memset(prefound,0x0,KPR_SIZE);
			size2=strlen(found);
			sz=size1-size2;
			strcpy(copy_line,"");
			strncpy(prefound,line,sz);
			post_found=found+strlen("%for_nexits");

			tmp_exit_node=cr->head_exit;
	
			while (tmp_exit_node!=0)
			{
			//	strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,prefound);	
				strcat(copy_line,"\"");
				strcat(copy_line,tmp_exit_node->ex_name);
				strcat(copy_line,"\" , ");
				strcat(copy_line,ROOM_PREFIX);
				strcat(copy_line," \"");
				strcat(copy_line,AREA_NAME);
				strcat(copy_line,tmp_exit_node->room_ptr->id);
				strcat(copy_line,FILE_EXT);
				strcat(copy_line,"\"");
				strcat(copy_line,ROOM_POSTFIX);
				strcat(copy_line,post_found);
				strcat(copy_line,"\n");
			
				tmp_exit_node=tmp_exit_node->next;
			}

			strcpy(line,copy_line);
		}
		
	}	

strcat(line,"\n");

	if (flag==0)
	{
		gtk_text_buffer_insert_at_cursor(
		(GtkTextBuffer*)textbuffer,line,strlen(line));

		gtk_text_view_set_buffer((GtkTextView*)textview,
		(GtkTextBuffer*)textbuffer);
	}

	if (flag==1)
	{
		fwrite(line,sizeof(char),strlen(line),fp);
	}
}	


int generate_room(char *fname,struct _vroom *cr, int flag, FILE *fp)
{
	char line[200];
	FILE *fl;
	char ch;
	int lptr;
	time_t bla;
	char sfname[400];
	char gen_lab_text[100];
	char *hmz;
	int bread;
	GtkWidget *mbox;
	//
	PangoFontDescription *fontdesc;
	//char prel[1000];
	GtkWidget *gen_label;
	

	if (flag==0)
	{
		fontdesc=pango_font_description_from_string(SOURCE_FONT);

		preview_dialog=create_dialog1();
		
		//glade refused to make it resizeable - oh well
		gtk_window_set_resizable(GTK_WINDOW(preview_dialog),TRUE);


		textbuffer=(GtkWidget*)gtk_text_buffer_new(NULL);
		textview=(GtkWidget*)lookup_widget(preview_dialog,"textview1");
		gtk_widget_show((GtkWidget*)preview_dialog);
		gen_label=(GtkWidget*)lookup_widget(preview_dialog,"label15");

		strcpy(gen_lab_text,"Editing room no: ");
		strcat(gen_lab_text,cr->id);
		gtk_label_set_text((GtkLabel*)gen_label,gen_lab_text);
	
		gtk_widget_modify_font(textview,fontdesc);
		pango_font_description_free(fontdesc);
	}
	
	
	//loading edited room;
	if (cr->edited==1)
	{
		hmz=getenv("HOME");
		strcpy(sfname,hmz);
		strcat(sfname,"/.mudsbuilder/.tmpsaved_");
		strcat(sfname,(char*)basename(get_areaname()));
		strcat(sfname,"_room");
		strcat(sfname,cr->id);

		fl=fopen(sfname,"r");

		if (fl<=0) 
		{
			g_print("Unable to open room file %s\n",sfname);
			mdialog_msg("Unable to open room file");
	
		}
		do
		{
			bread=getc(fl);
			if (bread!=EOF && bread!=-1) 
			{
				if (flag==0)
				gtk_text_buffer_insert_at_cursor(
				(GtkTextBuffer*)textbuffer,(char*)&bread,1);
				
				if (flag==1)
				putc(bread,fp);
			}
		}
		while (bread!=EOF);
		
		if (flag==0)
		{
			gtk_text_view_set_buffer((GtkTextView*)textview,
						(GtkTextBuffer*)textbuffer);
		} 

		
		fclose(fl);
		free(hmz);
		return;
	}
	

	if (access(fname,F_OK)==-1) {
		mdialog_msg("Warning: Template chosen cannot be found/opened\nPlease check your gereacreator.conf file");
		printf("%s file doesnt exist\n",fname);
		return -1;
	}
	
	memset(line,0x0,200);

	fl=0;
	fl=fopen(fname,"r");
	lptr=0;
	
	if (fl==0) {
		mdialog_msg("Warning: Template chosen cannot be found/opened\nPlease check your gereacreator.conf file");
		printf("Cannot open file\n");
		return -1;
	}
	
	do
	{
		ch=(int)getc(fl);
		
		if (ch!=EOF) {
			if (ch!='\n')
			{
				line[lptr]=ch;
				lptr++;
			} else {
				line[lptr]='\0';
				lptr=0;

				substitude(line,cr,flag,fp);
			}
		}
		
	}
	while (ch!=EOF);
	
	fclose(fl);
	return 0;
}




int generate_area(char *path)
{
	struct _vroom *tmp;
	FILE *ff;
	char *pp;
	extern struct _vroom *head;
	char *fnn;
	char *home_dir;
	
	tmp=head;
	home_dir=getenv("HOME");
	fnn=malloc(sizeof(char)*(strlen(home_dir)+strlen(MUDLIB_TEMPLATE)+100));
	pp=malloc(sizeof(char)*(strlen(path)+strlen(AREA_NAME)+strlen(FILE_EXT)+100));
	
	strcpy(fnn,home_dir);
	strcat(fnn,"/.mudsbuilder/");
	strcat(fnn,MUDLIB_TEMPLATE);

	while (tmp!=0)
	{
		strcpy(pp,path);
		strcat(pp,AREA_NAME);
		strcat(pp,tmp->id);
		strcat(pp,FILE_EXT);
		ff=fopen(pp,"w");
		
		generate_room(fnn,tmp,1,ff);
		fclose(ff);
		tmp=tmp->next;
	}

	free(home_dir);
	free(pp);

	free(fnn);
}
